Program Numbering;

Var Num:array[0..10] of boolean;
    s:string;
    l,i,N,k:int64;

Function Plus(a:int64):int64;
Var i:int64;
begin
 i:=(a mod 10)+1;
 While Num[i]=false do
   i:=i+1;
 if i=10 then
 begin
  a:=Plus(a div 10);
  i:=0;
 While Num[i]=false do
  i:=i+1;
  Plus:=a*10+i;
 end
 else
 Plus:=(a div 10)*10+i;
end;

begin
for i:=0 to 10 do
 Num[i]:=True;
 ReadLn(s);
 l:=Length(s);
 for i:=1 to l do
  if (ord(S[i])-ord('0'))<>-16 then
   Num[ord(S[i])-ord('0')]:=False;
 Read(N);
 i:=0;
 While Num[i]=false do
  i:=i+1;
 k:=0;
 While i<N do
 begin
  i:=Plus(i);
  k:=k+1;
 end;
 Write(k);
end.